"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
const Colors_1 = __importDefault(require("../Colors"));
const fontSize_1 = __importDefault(require("../Fn/fontSize"));
const { width, height } = react_native_1.Dimensions.get('window');
const $alert = width - 100;
const styles = react_native_1.StyleSheet.create({
    animate: {
        position: 'absolute',
        left: 0,
        top: 0,
        width,
        height,
        zIndex: 99999,
    },
    container: {
        backgroundColor: 'rgba(0,0,0,.6)',
        flex: 1,
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center',
    },
    box: {
        backgroundColor: '#fff',
        borderRadius: 10,
        overflow: 'hidden',
        padding: 20,
        minHeight: 200,
        maxHeight: 400,
    },
    title: {
        paddingBottom: 20,
        alignItems: 'center',
        justifyContent: 'center',
    },
    titleText: {
        fontSize: (0, fontSize_1.default)(17),
        fontWeight: '600',
        color: '#333',
    },
    content: {
        width: $alert,
        flex: 1,
    },
    contentText: {
        color: '#333',
        fontSize: (0, fontSize_1.default)(14),
        lineHeight: 20,
    },
    warp: {
        alignItems: 'center',
        justifyContent: 'space-between',
        flexDirection: 'row',
    },
    button: {
        backgroundColor: Colors_1.default.MainColor,
        height: 44,
        borderRadius: 44,
        borderWidth: 0.5,
        borderColor: Colors_1.default.MainColor,
        alignItems: 'center',
        justifyContent: 'center',
        flex: 1,
    },
    buttonText: {
        color: Colors_1.default.MainColor,
        fontSize: (0, fontSize_1.default)(15),
        fontWeight: '600',
    }
});
exports.default = styles;
