"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const toolkit_1 = require("@reduxjs/toolkit");
const initState = (name, init = {}, reducers = {}, async = null) => {
    if (!name)
        throw 'error';
    return (0, toolkit_1.createSlice)({
        name,
        initialState: init,
        reducers: Object.assign({ setStores: (state, { payload }) => {
                return Object.assign(Object.assign({}, state), payload);
            }, cleanStores: () => {
                return init;
            } }, reducers),
        extraReducers: (builder) => {
            if (!async)
                return;
            const item = async;
            Object.keys(item).forEach((v) => {
                const actions = item[v];
                builder.addCase(actions.pending, (state, action) => {
                    state.loading = 'pending';
                });
                builder.addCase(actions.fulfilled, (state, { payload = {} }) => {
                    state.loading = 'success';
                    state[v] = Object.assign({}, payload);
                });
                builder.addCase(actions.rejected, (state, action) => {
                    state.loading = 'failure';
                });
            });
        }
    });
};
exports.default = initState;
