"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const bottom_tabs_1 = require("@react-navigation/bottom-tabs");
const native_stack_1 = require("@react-navigation/native-stack");
const NavigatorBar_1 = __importDefault(require("../NavigatorBar"));
const react_redux_1 = require("react-redux");
const react_native_1 = require("react-native");
const Fetch_1 = __importDefault(require("../Fetch"));
const storage_1 = require("../Fn/storage");
const common_1 = require("../Fn/common");
const Config_1 = __importDefault(require("@components/Config"));
const geolocation_1 = __importDefault(require("@react-native-community/geolocation"));
const native_1 = require("@react-navigation/native");
const Tab = (0, bottom_tabs_1.createBottomTabNavigator)();
const Stack = (0, native_stack_1.createNativeStackNavigator)();
;
const TabsNavigation = ({ tabs = [], }) => {
    const { styleSafe } = (0, react_redux_1.useSelector)((state) => state.common);
    return (react_1.default.createElement(react_native_1.SafeAreaView, { style: Object.assign({}, styleSafe) },
        react_1.default.createElement(Tab.Navigator, { screenOptions: {
                headerShown: false,
                tabBarHideOnKeyboard: true,
            }, tabBar: (props) => react_1.default.createElement(NavigatorBar_1.default, Object.assign({}, props)) }, tabs.map((v, k) => {
            if (!v.tab)
                return null;
            return (react_1.default.createElement(Tab.Screen, { key: `itabs_${k}`, name: v.name, component: v.component, options: Object.assign({}, v) }));
        }))));
};
;
const Route = ({ routes = [], }) => {
    const navigationRef = (0, native_1.useNavigationContainerRef)();
    const dispatch = (0, react_redux_1.useDispatch)();
    const state = (0, react_redux_1.useSelector)((state) => state.common);
    const initLogin = () => __awaiter(void 0, void 0, void 0, function* () {
        yield (0, storage_1.$clearStorage)();
        navigationRef.resetRoot({
            index: 0,
            routes: [{ name: 'user/login' }],
        });
    });
    const initView = () => __awaiter(void 0, void 0, void 0, function* () {
        try {
            const res = yield (0, storage_1.$getStorage)('$$token');
            if (!(res === null || res === void 0 ? void 0 : res.accessToken)) {
                dispatch((0, common_1.$setCommon)({
                    isShow: true,
                    start: 'user/login'
                }));
                return;
            }
            const opts = {
                isShow: true,
                start: 'Index'
            };
            switch (Config_1.default.appType) {
                case 'SHOP':
                    opts.start = 'shop/index';
                    break;
                case 'RIDER':
                    opts.start = 'courier/index';
                    break;
                default:
                    opts.start = 'Index';
            }
            dispatch((0, common_1.$setCommon)(Object.assign({}, opts)));
        }
        catch (err) {
            dispatch((0, common_1.$setCommon)({
                isShow: true,
                start: 'user/login'
            }));
        }
    });
    (0, react_1.useEffect)(() => {
        initView();
        onGeolocation();
    }, []);
    (0, react_1.useEffect)(() => {
        if (!(state === null || state === void 0 ? void 0 : state.login))
            return;
        initLogin();
    }, [state === null || state === void 0 ? void 0 : state.login]);
    const onGeolocation = () => {
        if (Config_1.default.appType !== 'RIDER')
            return;
        geolocation_1.default === null || geolocation_1.default === void 0 ? void 0 : geolocation_1.default.getCurrentPosition((res) => {
            console.log('getCurrentPosition_success', res);
            putPosition(res);
        }, (err) => {
            console.log('getCurrentPosition_error', err);
        }, {
            enableHighAccuracy: true,
            maximumAge: 0
        });
        geolocation_1.default.watchPosition((res) => {
            console.log('watchPosition_success', res);
            putPosition(res);
        }, (err) => {
            console.log('watchPosition_error', err);
        }, {
            enableHighAccuracy: true,
            distanceFilter: 1000,
            maximumAge: 0,
            useSignificantChanges: false,
        });
    };
    const putPosition = (res) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            const token = yield (0, storage_1.$getStorage)('$$token');
            if (!(token === null || token === void 0 ? void 0 : token.accessToken))
                return;
            console.log('Fetch_position', {
                coordinateSys: 'GAODE',
                latitude: res.coords.latitude,
                longitude: res.coords.longitude,
            });
            (0, Fetch_1.default)('rider/rider/rider/uploadRiderPostion', {
                coordinateSys: 'GAODE',
                latitude: res.coords.latitude,
                longitude: res.coords.longitude,
            }, { method: 'PUT', toast: false, loading: false });
        }
        catch (err) {
            console.log('putPosition__error', err);
        }
    });
    const renderView = () => {
        if (!(state === null || state === void 0 ? void 0 : state.isShow))
            return null;
        return (react_1.default.createElement(Stack.Navigator, { initialRouteName: state.start || 'Index', screenOptions: {
                headerShown: false
            } },
            react_1.default.createElement(Stack.Screen, { name: 'Index' }, () => react_1.default.createElement(TabsNavigation, { tabs: routes })), routes === null || routes === void 0 ? void 0 :
            routes.map((v, k) => {
                if (v.tab)
                    return null;
                return (react_1.default.createElement(Stack.Screen, { key: `menu_${k}`, name: v.name, component: v.component }));
            })));
    };
    return (react_1.default.createElement(native_1.NavigationContainer, { ref: navigationRef }, renderView()));
};
exports.default = Route;
